/*
 * Copyright COCKTAIL (www.cocktail.org), 1995, 2012 This software 
 * is governed by the CeCILL license under French law and abiding by the
 * rules of distribution of free software. You can use, modify and/or 
 * redistribute the software under the terms of the CeCILL license as 
 * circulated by CEA, CNRS and INRIA at the following URL 
 * "http://www.cecill.info". 
 * As a counterpart to the access to the source code and rights to copy, modify 
 * and redistribute granted by the license, users are provided only with a 
 * limited warranty and the software's author, the holder of the economic 
 * rights, and the successive licensors have only limited liability. In this 
 * respect, the user's attention is drawn to the risks associated with loading,
 * using, modifying and/or developing or reproducing the software by the user 
 * in light of its specific status of free software, that may mean that it
 * is complicated to manipulate, and that also therefore means that it is 
 * reserved for developers and experienced professionals having in-depth
 * computer knowledge. Users are therefore encouraged to load and test the 
 * software's suitability as regards their requirements in conditions enabling
 * the security of their systems and/or data to be ensured and, more generally, 
 * to use and operate it in the same conditions as regards security. The
 * fact that you are presently reading this means that you have had knowledge 
 * of the CeCILL license and that you accept its terms.
 */
package org.cocktail.carambole.server.components;

// Generated by the WOLips Templateengine Plug-in at 26 juin 2007 15:27:50

import org.cocktail.carambole.server.MyAjaxPage;
import org.cocktail.fwkcktldepense.server.exception.FactoryException;
import org.cocktail.fwkcktldepense.server.finder.FinderCommande;
import org.cocktail.fwkcktldepense.server.finder.FinderFournisseur;
import org.cocktail.fwkcktldepense.server.metier.EOCommande;
import org.cocktail.fwkcktldepense.server.metier.EOExercice;
import org.cocktail.fwkcktldepense.server.metier.EOFournisseur;
import org.cocktail.fwkcktldepense.server.process.ProcessCommande;

import com.webobjects.appserver.WOComponent;
import com.webobjects.appserver.WOContext;
import com.webobjects.appserver.WOResponse;
import com.webobjects.eocontrol.EOEditingContext;
import com.webobjects.foundation.NSArray;

import er.extensions.eof.ERXEC;

public class CommandePrestationInterne extends MyAjaxPage {

	private static final long serialVersionUID = 1L;
	private EOFournisseur unDemandeur = null;
	private EOFournisseur leDemandeur = null;
	private NSArray<EOFournisseur> lesDemandeursPossibles = null;
	private boolean isEnregistrerDisabled = true;
	private Boolean isPI = null;
	private Boolean isCommande = null;

	public CommandePrestationInterne(WOContext context) {
		super(context);
	}

	public void appendToResponse(WOResponse res, WOContext ctx) {
		super.appendToResponse(res, ctx);
	}

	public void reset() {
		isEnregistrerDisabled = true;
		unDemandeur = null;
		leDemandeur = null;
		lesDemandeursPossibles = null;
		isPI = null;
		isCommande = null;
	}

	public void selectDemandeur() {
		if (isCommande.booleanValue()) {
			isEnregistrerDisabled = false;
			return;
		}

		EOCommande commande = laCommandeEnCours();
		if (commande != null) {
			commande.setFournisseurInterneClient(leDemandeur);
			if (leDemandeur != null) {
				isEnregistrerDisabled = false;
			}
			else {
				isEnregistrerDisabled = true;
			}
		}
	}

	public boolean isEnregistrerDisabled() {
		return isEnregistrerDisabled;
	}

	public WOComponent enregistrer() {
		WOComponent nextPage = null;

		EOCommande commande = laCommandeEnCours();
		if (getIsCommande().booleanValue() && commande.isPrecommande() == false && commande.isHorsMarche() && commande.isMAPA()) {
			nextPage = pageWithName("CommandeAttestationMAPA");
		}
		else {
			try {
				EOEditingContext edc = commande.editingContext();
				commande.setIsEnregistrerPI(!getIsCommande().booleanValue());
				ProcessCommande.enregistrer(session.dataBus(), edc, commande, utilisateurInContext(edc));
				session.setAlertMessage(null);
				// On refetche la commande pour la rafraichir
				EOExercice exercice = commande.exercice();
				Number numero = commande.commNumero();
				commande = FinderCommande.getCommande(ERXEC.newEditingContext(), exercice, numero);
				commande.setIsEnregistrerPI(!getIsCommande().booleanValue());
				session.setLaCommandeEnCours(commande);
				nextPage = pageWithName("CommandeApresEnregistrement");
			} catch (FactoryException e) {
				String alertMessage = e.getMessageFormatte();
				if (e.isBloquant()) {
					nextPage = null;
					if (e.isInformatif()) {
						// Exception contenant un message d'information pour l'utilisateur
						session.setAlertMessage(alertMessage);
					}
					else {
						e.printStackTrace();
						throw e;
					}
				}
				else {
					session.setAlertMessage(alertMessage);
					nextPage = pageWithName("CommandeApresEnregistrement");
				}
			} catch (RuntimeException e1) {
				session.setAlertMessage(e1.getMessage());
				e1.printStackTrace();
				throw e1;
			}
		}
		return nextPage;
	}

	public WOComponent annuler() {
		WOComponent nextPage = null;

		return nextPage;
	}

	public EOFournisseur getUnDemandeur() {
		return unDemandeur;
	}

	public void setUnDemandeur(EOFournisseur unDemandeur) {
		this.unDemandeur = unDemandeur;
	}

	public NSArray<EOFournisseur> getLesDemandeursPossibles() {
		EOCommande commande = laCommandeEnCours();
		EOEditingContext edc = commande.editingContext();
		if (lesDemandeursPossibles == null && commande != null) {
			leDemandeur = commande.fournisseurInterneClient();
			if (leDemandeur != null) {
				lesDemandeursPossibles = new NSArray<EOFournisseur>(leDemandeur);
				commande.setFournisseurInterneClient(leDemandeur);
				isEnregistrerDisabled = false;
			}
			else {
				lesDemandeursPossibles = FinderFournisseur.getFournisseursInternes(edc, utilisateurInContext(edc));
				if (lesDemandeursPossibles != null && lesDemandeursPossibles.count() == 1) {
					leDemandeur = (EOFournisseur) lesDemandeursPossibles.lastObject();
				}
				commande.setFournisseurInterneClient(leDemandeur);
				if (getIsPI().booleanValue() && leDemandeur == null) {
					isEnregistrerDisabled = true;
				}
				else {
					isEnregistrerDisabled = false;
				}
			}
		}
		return lesDemandeursPossibles;
	}

	public void setLesDemandeursPossibles(NSArray<EOFournisseur> lesDemandeursPossibles) {
		this.lesDemandeursPossibles = lesDemandeursPossibles;
	}

	public EOFournisseur getLeDemandeur() {
		return leDemandeur;
	}

	public void setLeDemandeur(EOFournisseur leDemandeur) {
		this.leDemandeur = leDemandeur;
	}

	public Boolean getIsCommande() {
		if (isCommande == null) {
			isCommande = Boolean.FALSE;
		}
		return isCommande;
	}

	public void setIsCommande(Boolean isCommande) {
		this.isCommande = isCommande;
		if (this.isCommande.booleanValue())
			isEnregistrerDisabled = false;
	}

	public Boolean getIsPI() {
		if (isPI == null) {
			isPI = Boolean.TRUE;
		}
		return isPI;
	}

	public void setIsPI(Boolean isPI) {
		this.isPI = isPI;
		if (this.isPI.booleanValue())
			selectDemandeur();
	}

}